<?
/*
 * $Horde$
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

include_once '../config/horde.php';
include_once '../lib/Horde.php';
include_once 'config/conf.php';
include_once 'version.inc';
include_once 'auth.inc';
include_once 'vars.inc';

// whups sections
$search = array(
    'fullname' => 'Search Tickets',
    'title'    => 'Search Tickets',
    'link'     => 't_search.php'
);

$create = array(
    'fullname' => 'Create Ticket',
    'title'    => 'Create Ticket',
    'link'     => 't_create.php'
);

$logout = array(
    'fullname' => 'Log Out',
    'title'    => 'Log Out',
    'link'     => 'logout.php'
);

$help = array(
    'fullname' => 'Help',
    'title'    => 'Help',
    'link'     => 'help.php'
);

$sections = array(
    'search' => $search,
    'create' => $create,
    'help'   => $help,
    'logout' => $logout
);

function getContactDetails() {
    return "Robert E. Coyle <robertecoyle@hotmail.com>";
}

function configError($error) {
    echo "<b>$error</b>";
}

function &createBackend() {
    global $conf;

    $type  = $conf['backend']['type'];
    $cname = "TicketBackend" . ucfirst($type);

    include_once "backend-$type.inc";

    if (!class_exists($cname)) {
	configError("No such backend '$type' found");
	exit;
    }

    $be = new $cname();
    $be->initialise();

    return $be;
}

function format_time($timestamp) {
    $ago = (int) (floor((time() - $timestamp) / (60 * 60 * 24)));

    if ($ago == 0)
	$ago = " (today)";
    else if ($ago == 1)
	$ago = " (yesterday)";
    else
	$ago = " ($ago days ago)";

    return strftime('%a %d %B', $timestamp) . $ago;
}

function format_time_full($timestamp) {
    $ago = (int) (floor((time() - $timestamp) / (60 * 60 * 24)));

    if ($ago == 0)
	$ago = " (today)";
    else if ($ago == 1)
	$ago = " (yesterday)";
    else
	$ago = " ($ago days ago)";

    return strftime('%c', $timestamp) . $ago;
}

function preserveVarByGet($baseurl, $name, $value) {
    if (strchr($baseurl, '?'))
	$join = '&';
    else
	$join = '?';

    $baseurl .= $join . urlencode($name) . '=' . urlencode($value);

    return $baseurl;
}

function preserveVarByPost($name, $value) {
    $name  = htmlspecialchars($name);
    $value = htmlspecialchars($value);

    echo '<input type="hidden" name="' . $name . '" value="' . $value . "\" />\n";
}

function pre_var_dump(&$var) {
    echo "<pre><span class=\"debug\">";
    var_dump($var);
    echo "</span></pre>\n";
}

function getmicrotime() {
    $t = microtime();
    $t = explode(' ', $t);

    return ($t[1] + $t[0]);
}

// tee hee hee - I love functions like this
function useForms($forms) {
    foreach ($forms as $f) {
	eval("function &get$f(&\$v, &\$b) {static \$f = ''; if (empty(\$f)) \$f = new $f(\$v, \$b); return \$f;}");
    }
}

?>
