<?
/*
 * $Horde$
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

include_once 'form.inc';

class CreateStep1Form extends Form {
    function CreateStep1Form(&$vars, &$backend) {
	$this->Form('createstep1form');

	$modules = $backend->getModules();
	$types = $backend->getTypes();

	$modtype = new EnumType($modules);
	$typetype = new EnumType($types);

	$var1 = new Variable('Module Name', 'module', $modtype, true);
	$var2 = new Variable('Ticket Type', 'type', $typetype, true);

	$this->addVariable($var1);
	$this->addVariable($var2);
    }
}

class CreateStep2Form extends Form {
    function CreateStep2Form(&$vars, &$backend) {
	$this->Form('createstep2form');

	$states = $backend->getStates($vars->getVar('type'), 'unconfirmed');

	if (WhupsAuth::getCanCreateNew()) {
	    $states2 = $backend->getStates($vars->getVar('type'), 'new');
	    $states = array_merge($states, $states2);
	}

	$priorities = $backend->getPriorities($vars->getVar('type'));

	$statetype = new EnumType($states);
	$prioritiestype = new EnumType($priorities);

	$var1 = new Variable('Ticket State', 'state', $statetype, true);
	$var2 = new Variable('Priority', 'priority', $prioritiestype, true);
	$var3 = new Variable('Description', 'comment', getLongTextType(), true);

	$this->addVariable($var1);
	$this->addVariable($var2);
	$this->addVariable($var3);
    }
}

?>
