#
# $Horde$
#
# Copywrite 2001 Robert E. Coyle <robertecoyle@hotmail.com>
#
# See the enclosed file COPYING for license information (GPL).  If you
# did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
#
# Database defs for Whups
#

CREATE TABLE ticket (
       id           INT NOT NULL,  # unique ticket id
       requester    INT	NOT NULL,  # user id of the creator of this ticket
       owner        INT	NOT NULL,  # user id of the currently assigned owner
       type         INT	NOT NULL,  # id into the type table, describing the type of ticket
       state        INT	NOT NULL,  # state of this ticket, meaning depends on the type of the ticket
       priority     INT	NOT NULL,  # priority, meaning depends on the type of the ticket
       module       INT	NOT NULL,  # module id that this ticket referres to
       comment      INT NOT NULL,  # id in the comment table - describes the ticket
       timestamp    DATETIME NOT NULL,  # redundant but useful, mirrored in the comment and state_log

       PRIMARY KEY (id)
);

CREATE TABLE type (
       id	    INT NOT NULL,
       name         VARCHAR(64) NOT NULL,
       description  VARCHAR(255),

       PRIMARY KEY (id)
);

CREATE TABLE state (
       type         INT NOT NULL,
       state        INT NOT NULL,
       name         varchar(64) NOT NULL,
       description  varchar(255),
       owner        INT NOT NULL,
       category     ENUM ('unconfirmed', 'new', 'assigned', 'resolved')
);

CREATE TABLE comment (
       id           INT NOT NULL,
       ticket_id    INT NOT NULL,
       creator      INT NOT NULL,
       comment      TEXT,
       timestamp    DATETIME,

       PRIMARY KEY (id)
);

CREATE TABLE state_log (
       ticket_id    INT NOT NULL,
       from_state   INT,
       to_state     INT NOT NULL,
       timestamp    DATETIME NOT NULL,
       owner        INT NOT NULL,
       explanation  TEXT NOT NULL
);

CREATE TABLE attachment (
       id           INT NOT NULL,
       name         VARCHAR(255) NOT NULL,
       comment_id   INT NOT NULL,
       mime_type    VARCHAR(255) NOT NULL,
       body         BLOB NOT NULL,

       PRIMARY KEY (id)
);

CREATE TABLE user (
       id           INT NOT NULL,
       name         VARCHAR(255) NOT NULL,
       email        VARCHAR(255) NOT NULL,
       password     VARCHAR(255) NOT NULL,

       PRIMARY KEY (id)
);

CREATE TABLE module (
       id           INT NOT NULL,
       name         VARCHAR(255),

       PRIMARY KEY (id)
);

CREATE TABLE priority (
       type         INT NOT NULL,
       priority     INT NOT NULL,
       name         VARCHAR(64),
       description  VARCHAR(255)
);

CREATE TABLE user_searches (
       user         INT NOT NULL,
       name         VARCHAR(255),
       getvars      VARCHAR(255) # FIXME: big enough?
);

CREATE TABLE ticket_listeners (
       ticket       INT NOT NULL,
       user         INT NOT NULL
);
