<?
/*
 * $Horde$
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

include_once 'common.inc';
include_once 'backend.inc';
include_once 'form.inc';

include_once 'createforms.inc';

include_once 'templates/page.inc';
include_once 'templates/headerbar.inc';
include_once 'templates/formrenderer.inc';

useForms(array(
    'CreateStep1Form',
    'CreateStep2Form'));

$PAGE      = new Page();
$HEADERBAR = new HeaderBar();
$RENDERER  = new FormRenderer();

$empty      = "";
$beendone   = 0;
$wereerrors = 0;

$backend = &createBackend();
WhupsAuth::initialise($backend);

$vars = &getDefaultVars($empty);
$form1 = &getCreateStep1Form($vars, $backend);

// start the page
$PAGE->open('Whups');
$HEADERBAR->bar($sections, 'create');

// what now?
$formname = $vars->getVar('formname');

if ($formname == 'createstep2form') {
    $form2 = &getCreateStep2Form($vars, $backend);

    $form1->validate($vars);
    $form2->validate($vars);

    if (!$form2->isValid() || !$form1->isValid()) {
	$formname = 'createformstep1';
    } else {
	// put that scumbag in the database!
	$form1->getInfo($vars, $info);
	$form2->getInfo($vars, $info);
	$results = $backend->addTicket($info);
	$tid = $results[0];
	$message = "Your ticket id is $tid. ";
	$message .= "An appropriate person has been notified of this request.\n";
	$message .= "<br /><br />\n";
	$message .= "Your ticket details are available at ";
	$message .= "<a href=\"" . Horde::url("t_details?id=$tid") . "\">the details page</a>\n";
	$RENDERER->beginInactive('Ticket created');
	$RENDERER->content($message);
	$RENDERER->end();
	$beendone = 1;
    }
}

if ($formname == 'createstep1form') {
    // stage 2
    $form1->validate($vars);

    if ($form1->isValid()) {
	$form2 = &getCreateStep2Form($vars, $backend);
	$form2->open($vars, 't_create.php', 'post');

	// render the original form readonly
	$RENDERER->beginInactive('Create Ticket - Stage 1');
	$form1->render($RENDERER, $vars, true);
	$RENDERER->end();

	// render the second stage form
	$RENDERER->beginActive("Create Ticket - Stage 2");
	$form2->render($RENDERER, $vars);
	$form2->submit($RENDERER, 'Submit');
	$RENDERER->end();

	$form2->close();

	$beendone = 1;
    }
}

if (!$beendone) {
    // front page
    $form1->open($vars, 't_create.php', 'post');
    $RENDERER->beginActive('Create Ticket - Stage 1');
    $form1->render($RENDERER, $vars, false);
    $form1->submit($RENDERER, 'Submit');
    $RENDERER->end();
    $form1->close();
}

$PAGE->close();

?>
