<?
/*
 * $Horde$
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

include_once 'common.inc';
include_once 'form.inc';

include_once 'searchforms.inc';

include_once 'templates/page.inc';
include_once 'templates/headerbar.inc';
include_once 'templates/formrenderer.inc';
include_once 'templates/comment.inc';
include_once 'templates/useractions.inc';

useForms(array(
    'TicketDetailsForm',
    'AddCommentForm',
    'AssignTicketStep1Form',
    'AssignTicketStep2Form',
    'SetStateStep1Form',
    'SetStateStep2Form',
    'SetPriorityStep1Form',
    'SetPriorityStep2Form'));

$PAGE = new Page();
$HEADERBAR = new HeaderBar();
$RENDERER = new FormRenderer();
$COMMENT = new Comment();

$beendone = 0;

$backend = &createBackend();
WhupsAuth::initialise($backend);

$vars = array('creator' => 1);
$vars = new WhupsVars($vars, $empty);
$vars = &getDefaultVars($vars);
$beendone = 0;
$info = array();

$ticket = $vars->getVarWasset('id', $wasset);
$from = $vars->getVar('formname');

// start the page
$PAGE->open('Whups: Ticket details');
$HEADERBAR->bar($sections, 'search');

// see if we're adding a comment
if ($from == 'addcommentform') {
    $addform = &getAddCommentForm($vars, $backend);
    $addform->validate($vars);

    if ($addform->isValid()) {
	$addform->getInfo($vars, $info);
	$backend->addComment($info);
	$vars->unsetVar('newcomment');
    }
}

// see if we're assigning this ticket
if ($from == 'assignticketstep2form') {
    $assignform1 = &getAssignTicketStep1Form($vars, $backend);
    $assignform2 = &getAssignTicketStep2Form($vars, $backend);

    $assignform1->validate($vars);
    $assignform2->validate($vars);

    if ($assignform1->isValid()) {
	if ($assignform2->isValid()) {
	    $assignform1->getInfo($vars, $info);
	    $assignform2->getInfo($vars, $info);
	    $backend->assignTicket($info);
	    $vars->unsetVar('assignee');
	    $vars->unsetVar('newcomment');
	} else {
	    $from = 'assignticketstep1form';
	}
    }
}

if ($from == 'assignticketstep1form') {
    $assignform1 = &getAssignTicketStep1Form($vars, $backend);
    $assignform1->validate($vars);

    if ($assignform1->isValid()) {
	$assignform2 = &getAssignTicketStep2Form($vars, $backend);

	$assignform2->open($vars, 't_details.php', 'post');

	$RENDERER->beginInactive('Assign Ticket - Stage 1');
	$assignform1->render($RENDERER, $vars, true);
	$RENDERER->end();

	$RENDERER->beginActive("Assign Ticket - Stage 2");
	$assignform2->render($RENDERER, $vars, false);
	$assignform2->submit($RENDERER, 'Assign');
	$RENDERER->end();

	$assignform2->close();
	$beendone = 1;
    }
}

// see if we're setting the ticket state
if ($from == 'setstatestep2form') {
    $setstateform1 = &getSetStateStep1Form($vars, $backend);
    $setstateform1->validate($vars);

    if ($setstateform1->isValid()) {
	$setstateform2 = &getSetStateStep2Form($vars, $backend);
	$setstateform2->validate($vars);

	if ($setstateform2->isValid()) {
	    $setstateform1->getInfo($vars, $info);
	    $setstateform2->getInfo($vars, $info);
	    $backend->setTicketState($info);
	    $vars->unsetVar('tostate');
	    $vars->unsetVar('newcomment');
	} else {
	    $from = 'setstatestep1form';
	}
    }
}

if ($from == 'setstatestep1form') {
    $setstateform1 = &getSetStateStep1Form($vars, $backend);
    $setstateform1->validate($vars);

    if ($setstateform1->isValid()) {
	$setstateform2 = &getSetStateStep2Form($vars, $backend);

	$setstateform2->open($vars, 't_details.php', 'post');

	$RENDERER->beginInactive('Set Ticket State - Stage 1');
	$setstateform1->render($RENDERER, $vars, true);
	$RENDERER->end();

	$RENDERER->beginActive("Set Ticket State - Stage 2");
	$setstateform2->render($RENDERER, $vars, false);
	$setstateform2->submit($RENDERER, 'Set State');
	$RENDERER->end();

	$setstateform2->close();
	$beendone = 1;
    }
}

// see if we're setting the ticket priority
if ($from == 'setprioritystep2form') {
    $setpriorityform1 = &getSetPriorityStep1Form($vars, $backend);
    $setpriorityform1->validate($vars);

    if ($setpriorityform1->isValid()) {
	$setpriorityform2 = &getSetPriorityStep2Form($vars, $backend);
	$setpriorityform2->validate($vars);

	if ($setpriorityform2->isValid()) {
	    $setpriorityform1->getInfo($vars, $info);
	    $setpriorityform2->getInfo($vars, $info);
	    $backend->setTicketPriority($info);
	    $vars->unsetVar('newpriority');
	    $vars->unsetVar('newcomment');
	} else {
	    $from = 'setprioritystep1form';
	}
    }
}

if ($from == 'setprioritystep1form') {
    $setpriorityform1 = &getSetPriorityStep1Form($vars, $backend);
    $setpriorityform1->validate($vars);

    if ($setpriorityform1->isValid()) {
	$setpriorityform2 = &getSetPriorityStep2Form($vars, $backend);

	$setpriorityform2->open($vars, 't_details.php', 'post');

	$RENDERER->beginInactive('Set Ticket Priority - Stage 1');
	$setpriorityform1->render($RENDERER, $vars, true);
	$RENDERER->end();

	$RENDERER->beginActive("Set Ticket Priority - Stage 2");
	$setpriorityform2->render($RENDERER, $vars, false);
	$setpriorityform2->submit($RENDERER, 'Set Priority');
	$RENDERER->end();

	$setpriorityform2->close();
	$beendone = 1;
    }
}

if (!$wasset || !IntType::isValid($vars, $ticket, $message)) {
    echo "I'm sorry, but you've got the wrong get vars.";
} else if (!$beendone) {
    $details = $backend->getTicketDetails($ticket);
    $comments = $backend->getComments($ticket);

    // we use info about the ticket in the forms below
    $vars = new WhupsVars($details, $vars);

    $form = &getTicketDetailsForm($vars, $backend);

    $RENDERER->beginInactive("Ticket $ticket Details");
    $form->render($RENDERER, new WhupsVars($details, $empty), true, false);
    $RENDERER->end();

    $COMMENT->begin();

    foreach ($comments as $key => $comment_values) {
	$COMMENT->render(new WhupsVars($comment_values, $empty));
    }

    $COMMENT->end();

    $addform = &getAddCommentForm($vars, $backend);

    $addform->open($vars, 't_details.php', 'post');
    $RENDERER->beginActive("Add comment");
    $addform->render($RENDERER, $vars, false);
    $addform->submit($RENDERER, 'Add comment');
    $RENDERER->end();
    $addform->close();

    $assignform1 = &getAssignTicketStep1Form($vars, $backend);

    $assignform1->open($vars, 't_details.php', 'post');
    $RENDERER->beginActive("Assign Ticket");
    $assignform1->render($RENDERER, $vars, false);
    $assignform1->submit($RENDERER, 'Assign');
    $RENDERER->end();
    $assignform1->close();

    $setstateform1 = &getSetStateStep1Form($vars, $backend);

    $setstateform1->open($vars, 't_details.php', 'post');
    $RENDERER->beginActive('Set Ticket State');
    $setstateform1->render($RENDERER, $vars, false);
    $setstateform1->submit($RENDERER, 'Set State');
    $RENDERER->end();
    $setstateform1->close();

    $setpriorityform1 = &getSetPriorityStep1Form($vars, $backend);

    $setpriorityform1->open($vars, 't_details.php', 'post');
    $RENDERER->beginActive('Set Ticket Priority');
    $setpriorityform1->render($RENDERER, $vars, false);
    $setpriorityform1->submit($RENDERER, 'Set Priority');
    $RENDERER->end();
    $setpriorityform1->close();
}

$PAGE->close();

?>
