<?
/*
 * $Horde$
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

include_once 'common.inc';
include_once 'backend.inc';
include_once 'form.inc';

include_once 'searchforms.inc';

include_once 'templates/page.inc';
include_once 'templates/headerbar.inc';
include_once 'templates/formrenderer.inc';
include_once 'templates/searchresults.inc';
include_once 'templates/useractions.inc';

useForms(array(
    'SearchForm',
    'SearchNarrow1Form'));

$PAGE = new Page();
$HEADERBAR = new HeaderBar();
$RENDERER = new FormRenderer();

$beendone = 0;

$backend = &createBackend();
WhupsAuth::initialise($backend);

$vars = &getDefaultVars();

// start the page
$PAGE->open('Whups');
$HEADERBAR->bar($sections, 'search');

// what now?
$module = $vars->getVarWasset('module', $wasset);
$form = &getSearchForm($vars, $backend);

if ($wasset) {
    $dosearch = 1;
    $form->validate($vars);

    if ($form->isValid()) {
	$form->getInfo($vars, $info);
	$type = $vars->getVar('type');

	if ($type) {
	    $form2 = getSearchNarrow1Form($vars, $backend);
	    $form2->validate($vars);

	    $dosearch = $form2->isValid();
	    $form2->getInfo($vars, $info);
	} else {
	    $form2 = $form;
	}

	if ($dosearch) {
	    $values = array(
		'Id'        => 'id',
		'State'     => '_state_name',
		'Type'      => '_type_name',
		'Priority'  => '_priority_name',
		'Module'    => '_module_name',
		'Timestamp' => 'timestamp'
		);

	    $tickets = &$backend->getTicketsByProperties($info);
	    $results = new SearchResults();

	    $results->results($tickets, $values);

	    $beendone = 1;
	}

	if (is_object($form2)) {
	    $form2->open($vars, 't_search.php');
	    $RENDERER->beginActive('Refine search');
	    $form->preserve($vars);
	    $form2->render($RENDERER, $vars, false);
	    $form2->submit($RENDERER, 'Submit');
	    $RENDERER->end();
	    $form2->close();

	    $beendone = 1;
	}
    }
}

if (!$beendone) {
    // front search page
    $ACTIONS = new UserActions();
    $mysearches = $backend->getUserSearches(WhupsAuth::getUserID(), 't_search.php');
    $ACTIONS->actions('My Searches', $RENDERER, $mysearches);

    $form->open($vars, 't_search.php');
    $RENDERER->beginActive('Search Tickets');
    $form->render($RENDERER, $vars, false);
    $form->submit($RENDERER, 'Submit');
    $RENDERER->end();
    $form->close();
}

$PAGE->close();

?>
